/**
 * generated by Xtext 2.12.0
 */
package org.eclipse.gemoc.formatting2;

import com.google.inject.Inject;
import java.util.Arrays;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gemoc.dsl.Dsl;
import org.eclipse.gemoc.dsl.Entry;
import org.eclipse.gemoc.services.DslGrammarAccess;
import org.eclipse.xtext.formatting2.AbstractFormatter2;
import org.eclipse.xtext.formatting2.IFormattableDocument;
import org.eclipse.xtext.formatting2.IHiddenRegionFormatter;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.xbase.lib.Extension;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

@SuppressWarnings("all")
public class DslFormatter extends AbstractFormatter2 {
  @Inject
  @Extension
  private DslGrammarAccess _dslGrammarAccess;
  
  protected void _format(final Dsl dsl, @Extension final IFormattableDocument document) {
    EList<Entry> _entries = dsl.getEntries();
    for (final Entry entry : _entries) {
      {
        document.<Entry>format(entry);
        final Procedure1<IHiddenRegionFormatter> _function = new Procedure1<IHiddenRegionFormatter>() {
          @Override
          public void apply(final IHiddenRegionFormatter it) {
            it.newLine();
          }
        };
        document.<Entry>append(entry, _function);
      }
    }
  }
  
  public void format(final Object dsl, final IFormattableDocument document) {
    if (dsl instanceof XtextResource) {
      _format((XtextResource)dsl, document);
      return;
    } else if (dsl instanceof Dsl) {
      _format((Dsl)dsl, document);
      return;
    } else if (dsl instanceof EObject) {
      _format((EObject)dsl, document);
      return;
    } else if (dsl == null) {
      _format((Void)null, document);
      return;
    } else if (dsl != null) {
      _format(dsl, document);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(dsl, document).toString());
    }
  }
}
